//+------------------------------------------------------------------+
//|                                                PercentChange.mq4 |
//|                                               Yuriy Tokman (YTG) |
//|                                               http://ytg.com.ua/ |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman (YTG)"
#property link      "http://ytg.com.ua/"
#property version   "1.00"
#property strict
#property indicator_chart_window

input int   MaxBars          = 300;
input int   DisplayDistance  = 5;
input color DisplayGainColor = clrGreen;
input color DisplayLossColor = clrRed;
input int   DisplayFontSize = 8;
input int   DisplayAfterComma = 2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   GetDell();
   Comment("");
//---   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   string perc,name;
   double _start;
//---
   int limit=rates_total-prev_calculated;
   if(prev_calculated==0)limit--;
   else  limit++;  
   if(MaxBars>0 && limit>MaxBars) limit=MaxBars;
//---
   for( int i=0; i<limit && !IsStopped(); i++)
    {
      //((a-b):((a+b):2))*100 
      //-  b-      
      _start = - ((Open[i]-Close[i])/((Open[i]+Close[i])/2)) * 100;
      //---
      if(_start>=0)
        {       
         name = "ytg_A-" + TimeToStr(Time[i], TIME_DATE|TIME_MINUTES);
         perc =DoubleToStr(_start, DisplayAfterComma) + "%";        
         TextCreate(0,name,0,Time[i],Low[i]-DisplayDistance*Point,perc,"Arial",DisplayFontSize,DisplayGainColor,90,ANCHOR_RIGHT);         
        }
      else if(_start<0)
        {
         name = "ytg_Y-" + TimeToStr(Time[i], TIME_DATE|TIME_MINUTES);
         perc =DoubleToStr(_start, DisplayAfterComma) + "%";        
         TextCreate(0,name,0,Time[i],High[i]+DisplayDistance*Point,perc,"Arial",DisplayFontSize,DisplayLossColor,90,ANCHOR_LEFT);
        }
     } 
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+ 
//|   ""                                           | 
//+------------------------------------------------------------------+ 
bool TextCreate(const long              chart_ID=0,               // ID  
                const string            name="Text",              //   
                const int               sub_window=0,             //   
                datetime                time=0,                   //    
                double                  price=0,                  //    
                const string            text="Text",              //   
                const string            font="Arial",             //  
                const int               font_size=10,             //   
                const color             clr=clrRed,               //  
                const double            angle=0.0,                //   
                const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //   
                const bool              back=false,               //    
                const bool              selection=false,          //    
                const bool              hidden=true,              //     
                const long              z_order=0)                //     
  { 
//---
 if(ObjectFind(name)>=0)ObjectDelete(name);// text    ,    
//---    
   ResetLastError(); 
//---   "" 
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,sub_window,time,price)) 
     { 
      Print(__FUNCTION__, 
            ":     \"\"!   = ",GetLastError()); 
      return(false); 
     } 
//---   
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text); 
//---    
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font); 
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size); 
//---     
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle); 
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor); 
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//---    (false)   (true)  
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//---  (true)   (false)     
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//---  (true)   (false)       
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//---   
   return(true); 
  } 
//----
void GetDell( string name = "ytg_")
 {
  string vName;
  for(int i=ObjectsTotal()-1; i>=0;i--)
   {
    vName = ObjectName(i);
    if (StringFind(vName,name) !=-1) ObjectDelete(vName);
   }
 }
//----
